=== ixp400_xscale_sw_no_ssl/Makefile ===
#
# Top level xscale_sw Makefile
# 
# File Version: $Revision: 1.291 $
# 
# -- Intel Copyright Notice --
# 
# Copyright 2002-2003 Intel Corporation All Rights Reserved.
# 
# The source code contained or described herein and all documents
# related to the source code ("Material") are owned by Intel Corporation
# or its suppliers or licensors.  Title to the Material remains with
# Intel Corporation or its suppliers and licensors.
# 
# The Material is protected by worldwide copyright and trade secret laws
# and treaty provisions. No part of the Material may be used, copied,
# reproduced, modified, published, uploaded, posted, transmitted,
# distributed, or disclosed in any way except in accordance with the
# applicable license agreement .
# 
# No license under any patent, copyright, trade secret or other
# intellectual property right is granted to or conferred upon you by
# disclosure or delivery of the Materials, either expressly, by
# implication, inducement, estoppel, except in accordance with the
# applicable license agreement.
# 
# Unless otherwise agreed by Intel in writing, you may not remove or
# alter this notice or any other notice embedded in Materials by Intel
# or Intel's suppliers or licensors in any way.
# 
# For further details, please see the file README.TXT distributed with
# this software.
# 
# -- End Intel Copyright Notice --
#
#

################################################################
# Determine the build host OS

include buildUtils/environment.linux.sh

# In a Tornado environment, WIND_HOST_TYPE should be set
ifeq ($(WIND_HOST_TYPE), x86-win32)
  IX_HOST_OS := windows
else
  ifeq ($(WIND_HOST_TYPE), sun4-solaris2)
    IX_HOST_OS := solaris
  else
    # Otherwise, try OSTYPE
    IX_HOST_OS := $(OSTYPE)
  endif
endif

# If we don't have a valid OS name, try to use the Unix uname command
# to find it.
ifeq (,$(filter $(IX_HOST_OS), linux solaris windows))
  IX_HOST_OS := $(shell uname)
  IX_HOST_OS := $(subst Linux,linux,$(IX_HOST_OS))
  IX_HOST_OS := $(subst SunOS,solaris,$(IX_HOST_OS))
# We do not check for 'cygwin' here, as a windows box will often have
# a cygwin "uname" on its PATH even when not running in a true cygwin
# environment. We must rely on the OSTYPE environment variable to tell
# us if we're in a true cygwin environment.
endif
# If we still don't know, assume it's Windows
ifeq (,$(filter $(IX_HOST_OS), linux solaris windows))
  IX_HOST_OS := windows
endif

################################################################
# Target OS selection

ifeq ($(IX_TARGET),linuxbe)
IX_TARGET_OS := linux
else
IX_TARGET_OS := vxworks
endif

################################################################
# Component lists
#
# Only check in the makefile with your component listed here if
# you know it will build.
# Components listed in BI_ENDIAN_COMPONENTS must work for both 
# big and little endian OSs.
#
#BI_ENDIAN_COMPONENTS := adsl atmdAcc atmm atmsch qmgr npeMh npeDl ethAcc ethDB ethMii hssAcc timerCtrl usb uartAcc ossl osServices featureCtrl perfProfAcc
BI_ENDIAN_COMPONENTS := qmgr npeMh npeDl ethAcc ethDB ethMii osServices featureCtrl ossl#hssAcc timerCtrl usb uartAcc ossl atmdAcc atmm atmsch 



COMPONENTS := $(BI_ENDIAN_COMPONENTS)

ifneq ($(IX_TARGET),vxle)
COMPONENTS += dmaAcc  
# vxWorks-only components
ifeq ($(IX_TARGET_OS),vxworks)
COMPONENTS += flashUpgrade
endif # TARGET_OS = vxworks
endif # !vxle

# Linux-only components
ifeq ($(IX_TARGET_OS),linux)
COMPONENTS += linux
endif


################################################################
# Codelet components
# Codeletes listed in BI_ENDIAN_CODELETS_COMPONENTS must work for both
# big and little endian OSs.
#BI_ENDIAN_CODELETS_COMPONENTS := ethAal5App hssAcc ethAcc usb timers perfProfAcc atm
BI_ENDIAN_CODELETS_COMPONENTS := hssAcc ethAcc usb timers



CODELETS_COMPONENTS := $(BI_ENDIAN_CODELETS_COMPONENTS)

ifneq ($(IX_TARGET),vxle)
CODELETS_COMPONENTS += dmaAcc  
endif # !vxle


################################################################
# List of all the components we know about
ALL_COMPONENTS := $(COMPONENTS) 
ALL_COMPONENTS += $(CODELETS_COMPONENTS:%=codelets_%)

################################################################
# vxWorks BSP selection
#
ifeq ($(IX_TARGET),vxbe)
BSP := ixdp425
else
BSP := ixdp425_le
endif

BSP_DIR := $(WIND_BASE)/target/config/$(BSP)

# Windows paths must use '\' as seperator for the MSDOS 'cd' command
ifeq ($(IX_HOST_OS),windows)
 BSP_DIR := $(subst /,\,$(BSP_DIR))
endif

################################################################
# Input directory - mostly for passing to sub-makes
# For linux, this is defined in the environment, for vxWorks the 
# name of the environment variable is different for historical 
# reasons.
ifeq ($(IX_TARGET_OS),vxworks)
IX_XSCALE_SW := $(CSR_BASE)
endif

################################################################
# Output directories 
#

OBJ_DIR := lib/$(IX_TARGET)
METRICS_DIR := metrics

OUTPUT_DIRS := lib $(OBJ_DIR) \
	$(foreach c, $(COMPONENTS), $(OBJ_DIR)/$c $(OBJ_DIR)/$c/test)
OUTPUT_DIRS += $(OBJ_DIR)/codelets \
	$(CODELETS_COMPONENTS:%=$(OBJ_DIR)/codelets/%)

################################################################
# Compiler & linker commands
#

ifeq ($(IX_TARGET_OS),vxworks)

# Suffix for Tornado tool names
ifeq ($(IX_TARGET),vxsim)
VX_TOOL_SUFFIX = simso
else
VX_TOOL_SUFFIX = arm
endif

  CC := cc$(VX_TOOL_SUFFIX)
LD := $(CC)
AR := ar$(VX_TOOL_SUFFIX)

# These are tools used to make a .out file with vxWorks ctor/dtor table.
NM := nm$(VX_TOOL_SUFFIX)
MUNCH := wtxtcl $(WIND_HOST_BASE)/host/src/hutils/munch.tcl -asm $(VX_TOOL_SUFFIX)
COMPILE_TRADITIONAL := $(CC) -c -fdollars-in-identifiers

else # IX_TARGET_OS == vxworks

LINUX_CROSS_COMPILE := arm-linux-
LD := $(LINUX_CROSS_COMPILE)ld -EB
CC := $(LINUX_CROSS_COMPILE)gcc
AR := $(LINUX_CROSS_COMPILE)ar

endif

################################################################
# Compiler & linker options
#

ifeq ($(IX_TARGET_OS),vxworks)
# vxWorks compiler flags
CFLAGS := -Wall -ansi -pedantic -DRW_MULTI_THREAD -D_REENTRANT \
	-Isrc/include -I$(WIND_BASE)/target/h -I$(BSP_DIR) \
	-I$(BSP_DIR)/../all -fno-common
# vxWorks linker flags
LDFLAGS := -nostdlib -r -Wl,-X
else
# linux compiler flags 

# For compatibility with MVL3.0, we need to check what compiler version we
# have, and use different flags for each.
CC_VERSION:=$(shell $(CC) --version)
ifneq (,$(findstring (GCC) 3.3.1, $(CC_VERSION)))
# We have the newer gcc version included in MVL3.1
LINUX_MACH_CFLAGS := -D__LINUX_ARM_ARCH__=5 -mcpu=xscale -mtune=xscale
else
# We have a MVL3.0 compiler
LINUX_MACH_CFLAGS := -march=armv4 -Wa,-mxscale -mtune=strongarm
endif # gcc version

CFLAGS :=  -mbig-endian -D__KERNEL__ -I$(LINUX_SRC)/include -Wall -Wno-trigraphs -fno-common -pipe -mapcs-32 -mshort-load-bytes -msoft-float -DMODULE -Isrc/linux -Isrc/include -D__linux -DCPU=33 -DXSCALE=33 $(LINUX_MACH_CFLAGS)

# Linux linker flags
LDFLAGS := -r
endif


ifdef IX_EXTRA_WARNINGS
# Optional "aggressive" warning flags. These will produce a lot of warning
# messages about Linux and vxWorks header files, but there should still be
# no warnings in Intel production code.
CFLAGS += -Wsign-compare -Wformat -Wstrict-prototypes -Wshadow -Wmissing-prototypes \
	-Wmissing-declarations -Wnested-externs -Winline -Waggregate-return \
	-fstrict-aliasing -fno-builtin -fsigned-char
endif

ifndef IX_MPHY
CFLAGS += -DIX_UTOPIAMODE=1
endif

ifdef IX_MPHYSINGLEPORT
CFLAGS += -DIX_MPHYSINGLEPORT=1
endif

ifeq ($(IX_TARGET_OS),linux)
# Default to build without debug symbols for Linux
IX_NOSYM := 1
endif

ifndef IX_NOSYM
CFLAGS += -ggdb3
endif

ifndef IX_NOOPT
CFLAGS += -O2
endif

ifdef IX_ENSURE_OFF
CFLAGS += -DIX_ENSURE_OFF
endif

ifdef IX_PRIVATE_OFF
CFLAGS += -DIX_PRIVATE_OFF
endif

ifndef IX_DEBUG
# Note: If you change the flags added here, be sure to modify the
# (filter-out) statement in the definition of
# ASM_C_RULES_UNITTEST_FLAGS to remove the same flags.
CFLAGS += -DNDEBUG
endif

# Target platform dependent options

ifeq ($(IX_TARGET),vxsim)
  CFLAGS += -DCPU=SIMSPARCSOLARIS
else
  ifeq ($(IX_TARGET_OS),vxworks)
    LDFLAGS += -Wl
    CFLAGS += -mcpu=xscale -mapcs-32 -mno-sched-prolog \
	-DCPU=XSCALE -DCPU_XSCALE -DARMMMU=ARMMMU_XSCALE \
	-DARMCACHE=ARMCACHE_XSCALE
    ifeq ($(IX_TARGET),vxle)
      LDFLAGS += -mlittle-endian 
      CFLAGS += -mlittle-endian -DARMEL -DLITTLE_ENDIAN_MODE
    else
      LDFLAGS += -mbig-endian 
      CFLAGS += -mbig-endian -DARMEB -DBIG_ENDIAN_MODE
    endif
  endif
endif

CFLAGS += $(IX_CFLAGS)
LDFLAGS += $(IX_LDFLAGS)

################################################################
# Other commands
#

# A sed command to process the output of $(CC) -M. It prepends a
# directory name to the object filename and adds the .d file to the
# rule as a rule target, and then appends the name of this makefile
# and the component makefile corresponding to the particular object as
# a dependency.
#
# Note the use of '=' rather than ':=' so that the value of $* will
# be evaluated later, when we use the command within a template rule.
#
# Note where '$$' is used in the sed commands, 'make' interprets it as
# a single '$'.
FILTER_DEPS = sed -e $(SAFE_QUOTE)s,$(notdir $*)\.o,$(OBJ_DIR)/$*.d $(OBJ_DIR)/$*.o,g$(SAFE_QUOTE) \
			-e $(SAFE_QUOTE)$$s,$$, src/$(dir $*)component.mk Makefile,$(SAFE_QUOTE)

# A command for printing trace messages in the makefile.
MAKEFILE_TRACE := @echo $(ECHO_QUOTE)--- Makefile: $(ECHO_QUOTE) # Use this setting to enable messages
#MAKEFILE_TRACE = @\#  # Use this setting to disable messages

################################################################
# Build platform specific macros
#
# These are : CMD_SEP : the string we use to seperate multiple
# 			commands on a single line.
#             ECHO_QUOTE : to print leading whitespace with the unix
#                       shells' echo command, we need quotes.
#             SAFE_QUOTE : the qoute character needed to enclose a 
#                       'sed' command.
#	      ECHO_BLANKLINE : The command to print an empty line.
#             RM : unconditionally delete file(s)

ifeq ($(IX_HOST_OS),windows)
# Windows settings
CMD_SEP := &&
ECHO_QUOTE := # cmd.exe's echo command doesn't need quotes
ECHO_BACKSLASH := \# comment needed to keep \ away from end of line
SAFE_QUOTE := "# " this comment is here to fix emacs syntax highlighting 
ECHO_BLANKLINE := @cmd.exe /c echo.
RM := vxrm 
# Windows doesn't have a 'touch' command. Warning! Unlike Unix touch,
# this will overwrite the existing file!
TOUCH_EMPTY_FILE := echo. >
else
# Unix settings
CMD_SEP := ;
ECHO_QUOTE := "# " this comment is here to fix emacs syntax highlighting 
ECHO_BACKSLASH := \\
SAFE_QUOTE := '# ' this comment is here to fix emacs syntax highlighting 
ECHO_BLANKLINE := @echo
RM := rm -f
TOUCH_EMPTY_FILE := touch
endif

################################################################
# Component makefiles
#

# Include component code makefiles
ifneq (0,$(words $(COMPONENTS)))
include $(COMPONENTS:%=src/%/component.mk)
endif
# COMPONENT_OBJ lists all of the object files in components
COMPONENT_OBJ := $(foreach c, $(COMPONENTS), $($(c)_OBJ:%=$(OBJ_DIR)/$(c)/%))

# Include codelet makefiles
ifneq (0,$(words $(CODELETS_COMPONENTS)))
include $(CODELETS_COMPONENTS:%=src/codelets/%/component.mk)
endif
# CODELETS_OBJ lists all the codelet objects
CODELETS_OBJ := $(foreach c, $(CODELETS_COMPONENTS), \
	$(codelets_$(c)_OBJ:%=$(OBJ_DIR)/codelets/$c/%))


# ALL_OBJ list all of the object files we know about
ALL_OBJ := $(COMPONENT_OBJ) $(CODELETS_OBJ)

# ALL_EXPORT_OBJ lists all of the object files that export symbols to
# the Linux kernel symbol table (This has no effect for non-linux
# builds).  Note that this list should be a subset of ALL_OBJ.
ALL_EXPORT_OBJ := $(foreach c, $(ALL_COMPONENTS), \
			$($(c)_EXPORT_OBJ:%=$(OBJ_DIR)/$(subst _,/,$(c))/%) \
		   )


################################################################
# Rules
#

# Default target
