=== source/Makefile ===
#========================================================
#
# Makefile for NAS storage project
#
# Author :          Argon Cheng (argon@suzhou.sercomm.com)
# Date   :          2004-07-22
#
#========================================================
include diff.mk

#========================================================
# DIFF_DIR
DIFF_DIR    :=  diff/$(MODULE_NAME_STRING)/$(VENDOR_NAME_STRING)

#-------------------------------------------------------#
#                       SUBLIBS                         #
#-------------------------------------------------------#

SUBLIBS   =   library

#-------------------------------------------------------#
#                       SUBDIRS                         #
#-------------------------------------------------------#

include $(DIFF_DIR)/subdirs.mk

#-------------------------------------------------------#
#                       TARGETS                         #
#-------------------------------------------------------#
.PHONY:  all libs dirs diff diffi install clean

ifeq ($(_SSL_SUPPORT_), 1)
all: diff link-files libs dirs
else
all: diff libs dirs
endif
	@echo Everything is OK!

libs : ${SUBLIBS}
	@mkdir -p lib
	@for i in ${SUBLIBS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;34m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i || exit 1 ;                                                   \
         done

dirs : ${SUBDIRS}
	@for i in ${SUBDIRS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;34m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i || exit 1 ;                                                   \
        done

diff:
	make -C $(DIFF_DIR)

diffi:
	make -C $(DIFF_DIR) install
	
link-files:
	if [ ! -e ./openssl-0.9.7d/Makefile ] ; then    \
            cd openssl-0.9.7d ; ./first.sh ; cd - ;     \
        fi

install: diffi
	@for i in ${SUBLIBS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;35m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i install || exit 1 ;                                           \
        done
	@for i in ${SUBDIRS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;35m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i install || exit 1 ;                                           \
        done

clean:
	for i in ${SUBLIBS} ; do make -C $$i clean || exit 1 ; done
	for i in ${SUBDIRS} ; do make -C $$i clean || exit 1 ; done
	rm -f lib/*

#=====================================================================================
# These targets are only for me :-)
.PHONY: mc m mi rami
mc:
	make -C library clean
	make -C utility clean
	make -C cgi clean
	make -C thttpd-2.23beta1 clean

m:
	make -C library
	make -C utility
	make -C cgi
	make -C thttpd-2.23beta1

mi:
	make -C library install
	make -C utility install
	make -C cgi install
	make -C thttpd-2.23beta1 install

rami:
	make -C $(DIFF_DIR) rami
