=== source/agetty/Makefile ===
# Makefile for agetty
#-----------------------------------------------------
TOPDIR  :=  $(shell /bin/pwd)
TOPDIR  :=  $(TOPDIR)/..

include $(TOPDIR)/prerules.mk
#-----------------------------------------------------

EXEC = agetty
OBJS = agetty.o
CFLAGS += -D__USE_BSD

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LDLIBS)
	$(STRIP) agetty

install:
	cp $(EXEC) $(T_BIN)

clean:
	rm -f $(EXEC) *.gdb *.elf *.o
