=== source/cgi/Makefile ===
#-----------------------------------------------------
TOPDIR  :=  $(shell /bin/pwd)
TOPDIR  :=  $(TOPDIR)/..

include $(TOPDIR)/prerules.mk
#-----------------------------------------------------

#-------------------------------------------------------#
#                       TARGETS                         #
#-------------------------------------------------------#

all:  

cgi: ${SUBDIRS}
	@for i in ${SUBDIRS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;34m                       cgi/$$i               \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i || exit 1 ;                                                   \
        done

install: 
clean:
#	for i in ${SUBDIRS} ; do make -C $$i clean || exit 1 ; done
