=== source/xfsprogs-2.6.3/debian/changelog ===
xfsprogs (2.6.3-1) unstable; urgency=low

  * New upstream release.
  * Add support for debian-installer.  (closes: #225444)
    Author: Steve Langasek.
  * Use debhelper instead of debmake, for proper udeb building.
    Author: Steve Langasek.
  * Drop boot-floppies support.  (closes: #112715)
    Author: Steve Langasek.
  * Add support for the security attribute namespace.

 -- Nathan Scott <nathans@debian.org>  Mon, 19 Jan 2004 10:08:59 +1100

xfsprogs (2.6.0-1) unstable; urgency=low

  * New upstream release.
  * Note: change in the mkfs algorithm for sizing allocation groups.

 -- Nathan Scott <nathans@debian.org>  Tue, 28 Oct 2003 15:23:48 +1100

xfsprogs (2.5.11-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Fri, 10 Oct 2003 09:37:57 +1000

xfsprogs (2.5.6-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Tue, 19 Aug 2003 09:44:48 +1000

xfsprogs (2.5.5-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Thu, 07 Aug 2003 12:58:36 +1000

xfsprogs (2.5.4-1) unstable; urgency=low

  * New upstream release, includes xfs_copy command
  * Fix shell quoting in xfs_bmap, from Kai S. Juse (closes: #202588)

 -- Nathan Scott <nathans@debian.org>  Wed, 23 Jul 2003 10:36:28 +1000

xfsprogs (2.5.3-1) unstable; urgency=low

  * New upstream release
  * Changed mkfs.xfs default log size scaling algorithm slightly, to
    create larger logs at smaller filesystem sizes by default
  * Enable support for sector sizes larger than 512 bytes

 -- Nathan Scott <nathans@debian.org>  Mon,  7 Jul 2003 16:06:21 +1000

xfsprogs (2.4.12-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Mon,  2 Jun 2003 13:51:06 +1000

xfsprogs (2.4.10-1) unstable; urgency=low

  * New upstream release
  * Add missing xfslibs-dev dependency on uuid-dev (closes: #193309)

 -- Nathan Scott <nathans@debian.org>  Thu, 15 May 2003 08:50:22 +1000

xfsprogs (2.4.9-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Fri,  2 May 2003 09:34:17 +1000

xfsprogs (2.4.4-1) unstable; urgency=low

  * New upstream release
  * Dependencies on libreadline4 and libreadline4-dev added

 -- Nathan Scott <nathans@debian.org>  Sun, 30 Mar 2003 10:30:18 +1000

xfsprogs (2.4.1-1) unstable; urgency=low

  * New upstream release
  * Updated policy version to which this package conforms
  * Note: unwritten extents are now enabled by default in mkfs.xfs

 -- Nathan Scott <nathans@debian.org>  Tue, 18 Mar 2003 16:16:43 +1100

xfsprogs (2.3.11-1) unstable; urgency=low

  * Add missing build dependency on gettext (closes: #181331)

 -- Nathan Scott <nathans@debian.org>  Tue, 18 Feb 2003 08:57:46 +1100

xfsprogs (2.3.10-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Mon, 17 Feb 2003 14:52:20 +1100

xfsprogs (2.3.6-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Thu, 31 Oct 2002 17:26:44 +1100

xfsprogs (2.3.5-1) unstable; urgency=low

  * New upstream release
  * Fix mkfs bug, patch from Anton Blanchard (closes: #163897)

 -- Nathan Scott <nathans@debian.org>  Mon,  7 Oct 2002 05:19:51 +1000

xfsprogs (2.3.4-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Mon,  7 Oct 2002 05:19:51 +1000

xfsprogs (2.3.0-1) unstable; urgency=low

  * New upstream release
  * Improve backwards compatibility of tools using the XFS geometry
    ioctl for older kernel versions which don't support the new ioctl

 -- Nathan Scott <nathans@debian.org>  Tue,  3 Sep 2002 09:55:48 +1000

xfsprogs (2.2.1-1) unstable; urgency=low

  * New upstream release
  * Default mkfs.xfs blocksize is now 4096 bytes, not getpagesize(2)
  * Fix to allow install process to work for newer autoconf versions

 -- Nathan Scott <nathans@debian.org>  Wed,  7 Aug 2002 11:37:23 +1000

xfsprogs (2.1.2-1) unstable; urgency=low

  * New upstream release
  * Support for the XFS version 2 log format

 -- Nathan Scott <nathans@debian.org>  Tue, 30 Jul 2002 09:49:08 +1000

xfsprogs (2.0.6-2) unstable; urgency=low

  * Fix a problem in xfs_repair's handling of ACLs

 -- Nathan Scott <nathans@debian.org>  Thu, 30 May 2002 17:22:05 +1000

xfsprogs (2.0.6-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Thu, 30 May 2002 14:31:30 +1000

xfsprogs (2.0.4-1) unstable; urgency=low

  * New upstream release, minor changes only

 -- Nathan Scott <nathans@debian.org>  Wed, 17 Apr 2002 15:30:52 +1000

xfsprogs (2.0.3-1) unstable; urgency=low

  * New upstream bugfix release

 -- Nathan Scott <nathans@debian.org>  Sat, 13 Apr 2002 09:45:06 +1000

xfsprogs (2.0.2-1) unstable; urgency=low

  * New upstream bugfix release

 -- Nathan Scott <nathans@debian.org>  Thu,  4 Apr 2002 12:11:01 +1100

xfsprogs (2.0.1-1) unstable; urgency=low

  * New upstream bugfix (minor) release

 -- Nathan Scott <nathans@debian.org>  Tue, 12 Mar 2002 13:25:32 +1100

xfsprogs (2.0.0-1) unstable; urgency=low

  * New upstream release with support for new libhandle interfaces
  * Major release for switch to official extended attributes syscalls

 -- Nathan Scott <nathans@debian.org>  Thu,  7 Feb 2002 13:25:26 +1100

xfsprogs (1.3.18-1) unstable; urgency=low

  * New upstream bugfix (minor) release

 -- Nathan Scott <nathans@debian.org>  Thu, 17 Jan 2002 11:13:19 +1100

xfsprogs (1.3.17-1) unstable; urgency=low

  * New upstream release
  * mkfs.xfs overwrites other filesystem signatures
  * xfs_repair fix for "avl_insert: duplicate range" bug

 -- Nathan Scott <nathans@debian.org>  Mon, 14 Jan 2002 10:59:50 +1100

xfsprogs (1.3.16-1) unstable; urgency=low

  * Remove temporary file use in xfs_db
  * Add "type text" command into xfs_db

 -- Nathan Scott <nathans@debian.org>  Mon, 17 Dec 2001 12:17:54 +1100

xfsprogs (1.3.15-1) unstable; urgency=low


