=== source/bftpd-1.0.22/debian/control ===
Source: bftpd
Section: net
Priority: extra
Maintainer: Max-Wilhelm Bruker <brukie@gmx.net>
Standards-Version: 3.0.1

Package: bftpd
Architecture: any
Depends: ${shlibs:Depends}
Description: A very configurable small FTP server
 bftpd is a very configurable and small FTP server that supports chroot
 without special directory preparation or configuration. Most FTP commands
 are supported.
