=== source/xfsprogs-2.6.3/debian/rules ===
#!/usr/bin/make -f

package = xfsprogs
develop = xfslibs-dev
bootpkg = xfsprogs-udeb

version = $(shell dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
target ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
udebpkg = $(bootpkg)_$(version)_$(target).udeb

dirtmp = debian/tmp
dirdev = debian/$(develop)
dirdi  = debian/$(bootpkg)
pkgtmp = DIST_ROOT=`pwd`/$(dirtmp); export DIST_ROOT;
pkgdev = DIST_ROOT=`pwd`/$(dirdev); export DIST_ROOT;
pkgdi  = DIST_ROOT=`pwd`/$(dirdi); export DIST_ROOT;
stdenv = @GZIP=-q; export GZIP;

options = DEBUG=-DNDEBUG; DISTRIBUTION=debian; LOCAL_CONFIGURE_OPTIONS=--enable-readline=yes; export DEBUG DISTRIBUTION LOCAL_CONFIGURE_OPTIONS;
diopts = $(options) OPTIMIZER=-Os; LOCAL_CONFIGURE_OPTIONS="--enable-shared-uuid=yes --enable-gettext=no"; export OPTIMIZER LOCAL_CONFIGURE_OPTIONS;
checkdir = test -f debian/rules

build: built
built: dibuild config
	@echo "== dpkg-buildpackage: build" 1>&2
	$(MAKE) default
	touch built

config: .census
.census:
	@echo "== dpkg-buildpackage: configure" 1>&2
	$(checkdir)
	$(options) $(MAKE) configure
	touch .census

dibuild: 
	$(checkdir)
	@echo "== dpkg-buildpackage: installer" 1>&2
	if [ ! -f mkfs/mkfs.xfs-$(bootpkg) ]; then \
		$(diopts) $(MAKE) configure; \
		for dir in include libxfs libdisk mkfs; do \
			$(MAKE) -C $$dir; \
		done; \
		mv mkfs/mkfs.xfs mkfs/mkfs.xfs-$(bootpkg); \
		$(MAKE) distclean; \
	fi

clean:
	@echo "== dpkg-buildpackage: clean" 1>&2
	$(checkdir)
	-rm -f built .census mkfs/mkfs.xfs-$(bootpkg)
	$(MAKE) distclean
	-rm -rf $(dirtmp) $(dirdev) $(dirdi) debian/*substvars debian/files*

binary-indep:

binary-arch: checkroot built
	@echo "== dpkg-buildpackage: binary-arch" 1>&2
	$(checkdir)
	-rm -rf $(dirtmp) $(dirdev) $(dirdi)
	$(pkgtmp) $(MAKE) -C . install
	$(pkgdev) $(MAKE) -C . install-dev
	$(pkgdi) $(MAKE) -C debian install-d-i
	$(pkgtmp) $(MAKE) -C build src-manifest

	dh_installdocs -p$(package) -p$(develop)
	dh_installchangelogs -N$(bootpkg)
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -p$(package)
	dh_installdeb -N$(bootpkg)
	dh_shlibdeps
	dh_gencontrol -N$(bootpkg)
	dh_gencontrol -p$(bootpkg) -- -n$(udebpkg)

	dh_md5sums -N$(bootpkg)
	dh_builddeb -N$(bootpkg)
	dh_builddeb -p$(bootpkg) --filename=$(udebpkg)

binary: binary-indep binary-arch

checkroot:
	test 0 -eq `id -u`

.PHONY: binary binary-arch binary-indep clean checkroot
